#include <string.h>

#include "asap.h"

/*
 * If "attr" is the name of a predefined attribute, "ASAPpredefAttr" returns
 * it, otherwise it returns "ATTR_UNKNOWN".
 */
ASAPpred_t      ASAPpredefAttr(attr)
    char           *attr;
{
    if ((strlen(attr) < 2) && (attr[0] != '@'))
	return ATTR_UNKNOWN;

    switch (attr[1]) {
    case 't':
	return (strcmp(attr, ATTR_TERMINATE_NAME) == 0
		? ATTR_TERMINATE : ATTR_UNKNOWN);
    case 'b':
	return (strcmp(attr, ATTR_BEGIN_NAME) == 0
		? ATTR_BEGIN : ATTR_UNKNOWN);
    case 'e':
	return (strcmp(attr, ATTR_END_NAME) == 0
		? ATTR_END : ATTR_UNKNOWN);
    case 'i':
	return (strcmp(attr, ATTR_INTR_NAME) == 0
		? ATTR_INTR : ATTR_UNKNOWN);
    default:
	return (ATTR_UNKNOWN);
    }

}

char           *ASAPpredefName(attr)
    ASAPpred_t      attr;
{
    switch (attr) {
    case ATTR_TERMINATE:
	return (ATTR_TERMINATE_NAME);
    case ATTR_BEGIN:
	return (ATTR_BEGIN_NAME);
    case ATTR_END:
	return (ATTR_END_NAME);
    case ATTR_INTR:
	return (ATTR_INTR_NAME);
    default:
	fatal("unkown attribute in ASAPpredefName");
    }
    /* NOTREACHED */
}
