#include <string.h>

#include <sys/param.h>
#include "asap.h"

/*
 * To be used to terminate a server. Should check something...
 */
ASAPstatus_t    ASAPterminate(conn)
    ASAPconn_t      conn;
{
    ASAPflush(conn.urgent);
    ASAPflush(conn.normal);

    /* send to the server... */
    ASAPsendAttrOp(conn.normal, "_", 0, 1);
    /* send termination attribute */
    ASAPsendAttrName(conn.normal, ASAPpredefName(ATTR_TERMINATE));
    /* and a (dummy) value */
    ASAPsendNInt(conn.normal, 0);
    ASAPflush(conn.normal);

    /* we now close the corresponding file descriptors */
    close(conn.urgent->in.fd);
    close(conn.normal->in.fd);
    /* and what about "out.fd" !!! */

    /* if the connection was in the UNIX domain, remove the two sockets */
    if (conn.path != (char *) 0) {
	/* "conn.path" is the normal one ... */
	unlink(conn.path);
	conn.path[strlen(conn.path) - 1] = 'u';
	unlink(conn.path);
    }
    return ASAP_SUCCESS;
}


/* To be used in a server... */
ASAPstatus_t    ASAPserverEnd(conn)
    ASAPconn_t      conn;
{
    ASAPflush(conn.urgent);
    ASAPflush(conn.normal);

    close(conn.urgent->in.fd);
    close(conn.normal->in.fd);
    return ASAP_SUCCESS;
}
