#include "myAll.h"
#include "myMem.h"
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <stdlib.h>


char           *myStrDup(char *s)
{
    char           *cs;

    if (s == NULL)
	return NULL;
    if ((cs = (char *) malloc((size_t) (sizeof(char) * (strlen(s) + 1)))) == (char *) NULL)
	error2(ER_NOMEM, "myStrDup");
    (void) strcpy(cs, s);
    return cs;
}

void           *myMalloc(size_t s)
{
    void           *tmp;

    if (s == 0)
	s = 1;			/* to avoid crash on Dec Alpha */
    if ((tmp = (void *) malloc(s)) != (void *) NULL)
	return tmp;
    else {
	char            t[MAX_CHAR_TMP];

	sprintf(t, "myMalloc of %d bytes", s);
	error2(ER_NOMEM, t);
	return NULL;
    }
}

void           *myMallocMsg(size_t s, char *msg)
{
    void           *tmp;

    if ((tmp = (void *) malloc(s)) != (void *) NULL)
	return tmp;
    else {
	char            t[MAX_CHAR_TMP];

	sprintf(t, "myMalloc of %d bytes ", s);
	error3(ER_NOMEM, msg, t);
	return NULL;
    }
}


void           *myRealloc(void *oldPt, size_t s)
{
    void           *tmp;

    if ((tmp = (void *) realloc(oldPt, s)) != (void *) NULL)
	return tmp;
    else {
	char            t[MAX_CHAR_TMP];

	sprintf(t, "myRealloc of %d bytes", s);
	error2(ER_NOMEM, t);
	return NULL;
    }
}

void           *myReallocMsg(void *oldPt, size_t s, char *msg)
{
    void           *tmp;

    if ((tmp = (void *) realloc(oldPt, s)) != (void *) NULL)
	return tmp;
    else {
	char            t[MAX_CHAR_TMP];

	sprintf(t, "myRealloc of %d bytes ", s);
	error3(ER_NOMEM, msg, t);
	return NULL;
    }
}


void           *myCalloc(int nbElt, int eltSz)
{
    void           *tmp;

    if ((tmp = (void *) calloc(nbElt, eltSz)) != (void *) NULL)
	return tmp;
    else {
	char            t[MAX_CHAR_TMP];

	sprintf(t, "myCalloc of %d bytes", nbElt * eltSz);
	error2(ER_NOMEM, t);
	return NULL;
    }
}

void           *myCallocMsg(int nbElt, int eltSz, char *msg)
{
    void           *tmp;

    if ((tmp = (void *) calloc(nbElt, eltSz)) != (void *) NULL)
	return tmp;
    else {
	char            t[MAX_CHAR_TMP];

	sprintf(t, "myCalloc of %d bytes ", nbElt * eltSz);
	error3(ER_NOMEM, msg, t);
	return NULL;
    }
}
