#include <stdio.h>
#include <fcntl.h>
#include "agattypes.h"



int             main(int argc, char **argv)
{
  int             end;

  if (argc != 2)
    error("usage: ty file_to_parse");
  initFirstAnalysis();
  curLgn = 0;
  curFile = "parameter for server ";
  addInclude(argv[1]);
  end = yywrap();
  if (end == 1) {
    fprintf(stderr, "Aborting: nothing to parse\n");
    myExit(1);
  }


  yyparse();
  semaCheck(allDef);
  if (nbError != 0) {
    char            tmp[MAX_CHAR_TMP];

    sprintf(tmp, "Aborting: found %d error%c\n",
	    nbError, ((nbError == 1) ? ' ' : 's'));
    fprintf(stderr, "%s\n", tmp);
    myExit(1);
  }

  displayFADef(allDef);


  computeConsts(allDef);

  htFree(htInclude, True);
  htFree(htConst, True);
  htFree(htMacro, True);
  htFree(htStream, True);
  return 0;
}
